package apimatic.mycalculator;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;

import io.apimatic.examples.Configuration;
import io.apimatic.examples.controllers.SimpleCalculatorController;
import io.apimatic.examples.http.client.APICallBack;
import io.apimatic.examples.http.client.HttpContext;
import io.apimatic.examples.models.GetCalculateInput;
import io.apimatic.examples.models.OperationTypeEnum;

public class MainActivity extends AppCompatActivity {
    private static final String TAG = "mpCalculator";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        Configuration.initialize(this);
        SimpleCalculatorController myCalculator = new SimpleCalculatorController();
        GetCalculateInput input = new GetCalculateInput();
        input.setX(2.0);
        input.setY(3.0);
        input.setOperation(OperationTypeEnum.SUM);

        myCalculator.getCalculateAsync(input, new APICallBack<String>() {
            @Override
            public void onSuccess(HttpContext context, String response) {
                Log.e(TAG, "The result is " + response);

            }

            @Override
            public void onFailure(HttpContext context, Throwable error) {
                Log.e(TAG, error.getMessage());
            }
        });

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
}
